const db = require('../db/models');
const PujasDBApi = require('../db/api/pujas');
const ValidationError = require('./notifications/errors/validation');

module.exports = class PujasService {
  static async create(data, currentUser) {
    const transaction = await db.sequelize.transaction();

    const result = await PujasDBApi.create(data, {
      currentUser,
      transaction,
    });

    if (result.statusCode !== 500) {
      await transaction.commit();
    } else {
      await transaction.rollback();
    }

    return result;

    // try {
    //   console.log(data);

    //   const result = await PujasDBApi.create(data, {
    //     currentUser,
    //     transaction,
    //   });

    //   console.log('RESULT ---> ', result);

    //   await transaction.commit();
    //   return result;
    // } catch (error) {
    //   console.log('ERROR !!!', error);
    //   await transaction.rollback();
    //   return new Error(error);
    // }
  }

  static async update(data, id, currentUser) {
    console.log('UPDATE WAS CALLED');
    const transaction = await db.sequelize.transaction();

    var pujaId = data.id;
    try {
      let pujas = await PujasDBApi.findBy({ id }, { transaction });

      if (!pujas) {
        throw new ValidationError('pujasNotFound');
      }

      await PujasDBApi.update(id, data, {
        currentUser,
        transaction,
      });

      await transaction.commit();
      return pujas;
    } catch (error) {
      await transaction.rollback();
      throw error;
    }
  }

  static async remove(id, currentUser) {
    // const transaction = await db.sequelize.transaction();

    // try {
    //   if (currentUser.role !== 'admin') {
    //     throw new ValidationError('errors.forbidden.message');
    //   }

    //   await PujasDBApi.remove(id, {
    //     currentUser,
    //     transaction,
    //   });

    //   await transaction.commit();
    // } catch (error) {
    //   await transaction.rollback();
    //   throw error;
    // }
try {
   await Promise.all([db.pujas.destroy({
    where: { id: id },
    force: true,
  }),

   db.puja_samagri_mappings.destroy({
    where: { puja_id: id },
    force: true,
  }),
   db.puja_history.destroy({
    where: { puja_id: id },
    force: true,
  })])

  return true;

} catch (error) {
  throw error;
}
    
}
};
